#include "stdio.h"
#define MAX 100

#include "geral.h"

struct SNo
{
   int chave;
   SNo * prox;
};

void Insere(int chave);
void Remove(int chave);
bool Contido(int k);
SNo * Busca(int k);
void Percorre();

SNo * Inicio = NULL; /* Topo aponta para nada */
SNo * Fim = NULL;

int main()
{
   bool x;
   
   Insere(4);
   Insere(8);
   Insere(10);
   Insere(20);
   printf("Achou 4: %i \n",Contido(4));
   printf("Achou 8: %i \n",Contido(8));
   printf("Achou 10: %i \n",Contido(10));
   printf("Achou 20: %i \n",Contido(20));
   printf("Achou 40: %i \n",Contido(40));
   printf("Achou 5: %i \n",Contido(5));
   Percorre();   
   Remove(10);
   Percorre();
   Remove(4);
   Percorre();
   Remove(8);
   Percorre();
   Remove(20);
   Percorre();

   
   
}


SNo * Busca(int k)
{
   SNo * no;
   bool achou=FALSE;
   
   no = Inicio;
   while(no!=NULL && achou==FALSE)
   {
      if(no->chave == k) achou = TRUE;
      else no = no->prox;
   }
   return(no);
}

bool Contido(int k)
{
   if(Busca(k)==NULL) return(FALSE);
   else return(TRUE);
}

void Insere(int chave)
{
   SNo * No;
   
   No = new SNo;
 
   
   if(No==NULL) printf("Memoria Insuficiente");
   else
   {
      No->chave = chave;
      No->prox = NULL;

      if(Inicio == NULL)
      {
         Inicio = Fim = No;
      }
      else
      {
         Fim->prox = No;
         Fim = No;
      }
   }
}

void Remove(int k)
{
   SNo * no, * predec;
   bool achou=FALSE;
   
   no = Inicio;
   predec = NULL;
   while(no!=NULL && achou==FALSE)
   {
      if(no->chave == k) 
      {
         achou = TRUE;
         break;
      }
      predec = no;
      no = no->prox;
   }
   if(achou == TRUE)
   {
      if(Inicio==no) Inicio = no->prox;
      if(Fim==no) Fim = predec;  
      if(predec!=NULL) predec->prox = no->prox;
      delete no;
   }
}


void Percorre()
{
  SNo * no;
  
  no = Inicio;
  while(no!=NULL)
  {
     printf("%i ",no->chave);
     no = no->prox;
  }
  printf("\n");
}