#include "stdio.h"
#define MAX 100

#include "geral.h"

struct SNo
{
   int chave;
   SNo * prox;
   SNo * ant;
};

void Insere(int chave);
void Remove(int chave);
bool Contido(int k);
SNo * Busca(int k);
SNo * BuscaPontoInsercao(int k);
void Percorre();
void PercorreI();

SNo * Inicio = NULL; /* Topo aponta para nada */
SNo * Fim = NULL;

int main()
{
   bool x;
   
   Insere(8);
   Percorre();  
   Insere(4);
   Percorre();  
   Insere(20);
   Percorre();  
   Insere(10);
   Percorre();  
   printf("Achou 4: %i \n",Contido(4));
   printf("Achou 8: %i \n",Contido(8));
   printf("Achou 10: %i \n",Contido(10));
   printf("Achou 20: %i \n",Contido(20));
   printf("Achou 40: %i \n",Contido(40));
   printf("Achou 5: %i \n",Contido(5));
   Percorre();  
   PercorreI(); 
   Remove(10);
   Percorre();
   Remove(4);
   Percorre();
   Remove(8);
   Percorre();
   Remove(20);
   Percorre();
   
}


SNo * Busca(int k)
{
   SNo * no;
   bool achou=FALSE;
   
   no = Inicio;
   while(no!=NULL && achou==FALSE)
   {
      if(no->chave == k) achou = TRUE;
      else no = no->prox;
   }
   return(no);
}

SNo * BuscaPontoInsercao(int k)
{
   SNo * no;
   bool achou=FALSE;

  
   no = Inicio;
   while(no!=NULL && achou==FALSE)
   {
      if(no->chave > k) 
      {
         achou = TRUE;
      }
      else no = no->prox;
   }
   if(achou==FALSE) return(Fim);
   else return(no->ant);
}

bool Contido(int k)
{
   if(Busca(k)==NULL) return(FALSE);
   else return(TRUE);
}

void Insere(int k)
{
   SNo * No;
   SNo * Lugar;
   
   No = new SNo;
  
      
   if(No==NULL) printf("Memoria Insuficiente");
   else
   {
   
      No->chave = k;
      No->prox = NULL;
      No->ant = NULL;
      
      Lugar = BuscaPontoInsercao(k);
      
      if(Inicio == NULL)
      {
         Inicio = Fim = No;
      }
      else
      {
         if(Lugar == NULL) /* Inicio da Fila */
         {
            Inicio->ant = No;
            No->prox = Inicio;
            Inicio = No;
         }
         else 
         {
            No->prox = Lugar->prox;
            No->ant  = Lugar;
            if(Lugar->prox != NULL)
            {
               Lugar->prox->ant = No;    
            }
            Lugar->prox = No;
            if(Fim==Lugar)
            {
               Fim = No;
            }
         }
      }
   }
}

void Remove(int k)
{
   SNo * no;
   
   no = Busca(k);
   
   if(no != NULL)
   {
      if(Inicio==no) Inicio = no->prox;
      if(Fim==no) Fim = no->ant;  
      if(no->ant!=NULL) no->ant->prox = no->prox;
      if(no->prox!=NULL) no->prox->ant = no->ant;
      delete no;
   }
}


void Percorre()
{
  SNo * no;
  
  no = Inicio;
  while(no!=NULL)
  {
     printf("%i ",no->chave);
     no = no->prox;
  }
  printf("\n");
}

void PercorreI()
{
  SNo * no;
  
  no = Fim;
  while(no!=NULL)
  {
     printf("%i ",no->chave);
     no = no->ant;
  }
  printf("\n");

}